package com.ruoyi.service.impl;

import com.ruoyi.domain.ReviewScene;
import com.ruoyi.domain.ReviewSceneChangeTask;
import com.ruoyi.domain.ReviewUsecase;
import com.ruoyi.mapper.ReviewUsecaseMapper;
import com.ruoyi.service.StrategyReviewSceneChange;
import com.ruoyi.service.ReviewSceneService;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Objects;

@Transactional
@Service
public class StrategyReviewSceneChangeUpdate implements StrategyReviewSceneChange, InitializingBean {

    @Autowired
    private StrategyReviewSceneChangeContext strategyReviewSceneChangeContext;
    @Autowired
    private ApplicationContext applicationContext;

    @Autowired
    private ReviewUsecaseMapper reviewUsecaseMapper;
    @Autowired
    private ReviewSceneService reviewSceneService;
    @Override
    public void doChange(ReviewSceneChangeTask reviewSceneChangeTask) {
        if (Objects.equals(reviewSceneChangeTask.getOperationSort(),"UPDATE_SCENE")){
            ReviewScene reviewScene = reviewSceneService.getById(reviewSceneChangeTask.getReviewSceneId());
            reviewScene.setText(reviewSceneChangeTask.getNewText());

            reviewSceneService.updateById(reviewScene);
        }

        if (Objects.equals(reviewSceneChangeTask.getOperationSort(),"UPDATE_USECASE")){
            ReviewUsecase reviewUsecase = reviewUsecaseMapper.getById(reviewSceneChangeTask.getReviewUsecaseId());
            reviewUsecase.setUsecaseDescribe(reviewSceneChangeTask.getUsecaseDescribe());
            reviewUsecase.setUsecaseId(reviewSceneChangeTask.getNewText());

            reviewUsecaseMapper.updateById(reviewUsecase);
        }
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        strategyReviewSceneChangeContext.putResource(ReviewSceneChangeTask.OPERATION_UPDATE, applicationContext.getBean(this.getClass()));
    }
}
